import cv2 as cv
import numpy as np
import matplotlib.pyplot as plt

def rgb2gray(x):
    return cv.cvtColor(x,cv.COLOR_BGR2GRAY)

cap = cv.VideoCapture(0)

# para comparar con matplotlib
MPL = False

if MPL:
    fig1 = plt.figure()
    l1, = plt.plot([], [], '-r',lw=2)
    plt.xlim(0,255)
    plt.ylim(0,10000)
    plt.ion()
    plt.show()

while(True):
    if cv.waitKey(1) & 0xFF == 27: break

    ret, frame = cap.read()
    
    x = rgb2gray(frame)
    
    h,b = np.histogram(x, bins=256, range=(0,256))
    
    # ajustar el histograma para que se vea más o menos bien en la imagen
    kk = np.array([2*b[1:], 480-h*(480/10000)]).T.astype(int)
    cv.polylines(x,[kk], isClosed=False, color=(0,0,255), thickness=2)
    cv.imshow('histogram',x)

    if MPL:
        l1.set_data(b[1:],h);
        plt.draw()
        plt.pause(0.001)
    
