import cv2 as cv
import numpy as np
import time

def putText(img,s,pt,col=(0,0,128)):
    (x,y) = pt
    cv.putText(img, s, (x,y), cv.FONT_HERSHEY_PLAIN, 1, col, 1, cv.LINE_AA)


cap = cv.VideoCapture(0)

hog = cv.HOGDescriptor()
hog.setSVMDetector(cv.HOGDescriptor_getDefaultPeopleDetector())

MULTISCALE = True

while (cv.waitKey(1) != 27):
    ret, frame = cap.read()

    image = cv.resize(frame,(400,300))
    

    if MULTISCALE:
        t0 = time.time()
        (rects, weights) = hog.detectMultiScale(image, winStride=(4, 4), padding=(8, 8), scale=1.1)
        t1 = time.time()    

        if len(rects) > 0:
            for (x, y, w, h), p in zip(rects,weights.flatten()):
                cv.rectangle(image, (x, y), (x + w, y + h), (0, 0, 255), 2)
                putText(image,'{:.1f}'.format(p),(x,y-10),(0,128,255))
        
    else:

        t0 = time.time()
        (rects, weights) = hog.detect(image, winStride=(4, 4), padding=(8, 8))    
        t1 = time.time()    

        if len(rects) > 0:
            for (x, y), p in zip(rects,weights.flatten()):
                cv.rectangle(image, (x, y), (x + 64, y + 128), (0, 0, 255), 2)
                putText(image,'{:.1f}'.format(p),(x,y-10),(0,128,255))

    putText(image,'{:.0f} ms'.format((t1-t0)*1000),(5,20),(0,255,128))
    cv.imshow('webcam',image)

