#!/usr/bin/env python

import cv2          as cv
import numpy        as np
import numpy.linalg as la
import argparse
import datetime

from umucv.stream import mkStream, withKey

parser = argparse.ArgumentParser()
parser.add_argument('--dev', type=str, default='0',
                    help='image source ("picam" for raspberry pi camera)')
parser.add_argument('--width', help='image width', type=int, default=640)
args = parser.parse_args()

aspect_ratio = 4./3
WIDTH = args.width
HEIGHT = int(round(WIDTH/aspect_ratio))
size = (WIDTH,HEIGHT)

stream = mkStream(size, args.dev)

for key,frame in withKey(stream):
    cv.imshow('input',frame)
    if key == ord('s'):
            fname = datetime.datetime.now().strftime("%Y%m%d-%H%M%S")
            cv.imwrite(fname+'.png',frame)

